import logging
import unittest
import threading
import time
import sys
import io
from unittest.mock import patch
from geniusweb.inform.Inform import Inform

from geniusweb.partystdio.StdInOutConnectionEnd import StdInOutConnectionEnd
from tudelft.utilities.listener.Listener import Listener

class SimpleListener(Listener[Inform]):
	def __init__(self):
		self.received=[]
		
	def notifyChange(self, info: Inform):
		self.received.append(info)
	

class StdInOutTest(unittest.TestCase):
	def testSmoke(self):
		StdInOutConnectionEnd()
		
	
	def testRun(self):
		print("TESTING STDINOUT")
		data=bytes("abc", 'utf-8')
		data2=bytes("nog een blokje met rotte chars \n en \0 enzo", 'utf-8') 
		fname="test.bin"
		
		listener=SimpleListener()
		
		with open(fname, "wb") as f:
			f.write(len(data).to_bytes(4,'little'))
			f.write(data)
			
			f.write(len(data2).to_bytes(4,'little'))
			f.write(data2)


		std=sys.stdin
		sys.stdin = open(fname,'r') 
		StdInOutConnectionEnd().run(listener)
		#sys.stderr.write("test")
		sys.stdin=std
		self.assertEquals(data,listener.received[0])
		self.assertEquals(data2,listener.received[1])
		
def printsize(buf):
	print("args="+str(buf))
	time.sleep(0.1)
	buf.write('82128')
	